Talentd
FleetCode

1269. Number of Ways to Stay in the Same Place After Some Steps

Hard50.2% acceptance1 company

You have a pointer at index 0 in an array of size arrLen. At each step, you can move 1 position to the left, 1 position to the right in the array, or stay in the same place (The pointer should not be placed outside the array at any time).

Given two integers steps and arrLen, return the number of ways such that your pointer is still at index 0 after exactly steps steps. Since the answer may be too large, return it modulo 109 + 7.

Example 1:

Input: steps = 3, arrLen = 2
Output: 4
Explanation: There are 4 differents ways to stay at index 0 after 3 steps.
Right, Left, Stay
Stay, Right, Left
Right, Stay, Left
Stay, Stay, Stay

Example 2:

Input: steps = 2, arrLen = 4
Output: 2
Explanation: There are 2 differents ways to stay at index 0 after 2 steps
Right, Left
Stay, Stay

Example 3:

Input: steps = 4, arrLen = 2
Output: 8

Constraints:

  • 1 <= steps <= 500
  • 1 <= arrLen <= 106

Asked at 1 company

Hints open one at a time

Hint 1
Try with Dynamic programming, dp(pos,steps): number of ways to back pos = 0 using exactly "steps" moves.
Hint 2
Notice that the computational complexity does not depend of "arrlen".
20:57
Still stuck?Read 3 approaches, or watch a walkthrough.
Open solution
Loading editor…
1class Solution:
2 def numWays(self, steps: int, arrLen: int) -> int:
3
Starter codePython 3Spaces: 4
Examples
Input
3
2
Input
2
4
Input
4
2
Your code is saved on this device.Solution